/// An offset that can be applied to a run.
#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct RunOffset {
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::Offset>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "offset", skip_serializing_if = "Option::is_none", default)]
    offset: Option<Box<super::Offset>>,
    #[builder(default, into)]
    #[serde(rename = "assets", skip_serializing_if = "Option::is_none", default)]
    assets: Option<
        std::collections::BTreeMap<
            super::super::super::rids::api::AssetRid,
            super::AssetOffset,
        >,
    >,
}
impl RunOffset {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new() -> Self {
        Self::builder().build()
    }
    #[inline]
    pub fn offset(&self) -> Option<&super::Offset> {
        self.offset.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn assets(
        &self,
    ) -> Option<
        &std::collections::BTreeMap<
            super::super::super::rids::api::AssetRid,
            super::AssetOffset,
        >,
    > {
        self.assets.as_ref().map(|o| &*o)
    }
}
